"use strict";
/* BEGIN LICENSE BLOCK

QuickFolders is released under the Creative Commons (CC BY-ND 4.0)
Attribution-NoDerivatives 4.0 International (CC BY-ND 4.0) 
For details, please refer to license.txt in the root folder of this extension

END LICENSE BLOCK */

QuickFolders.Licenser = {
  showDialog: function showDialog(featureName) {
		let params = {inn:{referrer:featureName, instance: QuickFolders}, out:null};
    window.openDialog('chrome://quickfolders/content/register.xul','quickfolders-register','chrome,titlebar,centerscreen,resizable,alwaysRaised,instantApply',QuickFolders,params).focus();
  } ,
  
  accept: function accept() {
  
  } ,
  
  cancel: function cancel() {
  
  } ,
  
  load: function load() {
    function appendIdentity(dropdown, id, account) {
      if (!id.email) {
        QuickFolders.Util.logToConsole('Omitting account ' + id.fullName + ' - no mail address');
        return;
      }
      let menuitem = document.createElement('menuitem');
      menuitem.setAttribute("id", "id" + idCount++);
      // this.setEventAttribute(menuitem, "oncommand","QuickFolders.Interface.onGetMessages(this);");
      menuitem.setAttribute("fullName", id.fullName);
      menuitem.setAttribute("value", id.email);
      menuitem.setAttribute("accountKey", account.key);
      menuitem.setAttribute("label", id.identityName ? id.identityName : id.email);
      dropdown.appendChild(menuitem);
    }
    let idCount = 0;
    
    let util = QuickFolders.Util; 
		if (window.arguments && window.arguments[1].inn.referrer) {
      let ref = document.getElementById('referrer');
      ref.value = window.arguments[1].inn.referrer;
    }
    
    let accounts = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager).accounts;
    let aAccounts;
    if (util.Application == 'Postbox') 
      aAccounts = util.getAccountsPostbox();
    else {
      aAccounts = [];
      for (let ac in fixIterator(accounts, Components.interfaces.nsIMsgAccount)) {
        aAccounts.push(ac);
      };
    }
    // iterate accounts
    let idSelector = document.getElementById('mailIdentity');
    let popup = idSelector.menupopup;
    for each (let ac in aAccounts) { 
      if (ac.defaultIdentity) {
        appendIdentity(popup, ac.defaultIdentity, ac);
        continue;
      }
      let ids = ac.identities; // array of nsIMsgIdentity 
      if (ids) {
        for (let i=0; i<ids.length; i++) {
          // use ac.defaultIdentity ??
          // populate the dropdown with nsIMsgIdentity details
          let id = ids.queryElementAt(i, Components.interfaces.nsIMsgIdentity);
          if (!id) continue;
          appendIdentity(popup, id, ac);
        }
      }      
    }
    // select first item
    idSelector.selectedIndex = 0;
    this.selectIdentity(idSelector);
    
  } ,
  
  sanitizeName: function sanitizeName(name) {
    // remove bracketed stuff: "fred jones (freddy)" => "fred jones"
    let x = name.replace(/ *\([^)]*\) */g, "");
    if (x.trim)
      return x.trim();
    return x
  },
  
  selectIdentity: function selectIdentity(element) {
    // get selectedItem attributes
    let it = element.selectedItem;
    let fName = this.sanitizeName(it.getAttribute('fullName'));
    let email = it.getAttribute('value');
    let names = fName.split(' ');
    document.getElementById('firstName').value = names[0];
    document.getElementById('lastName').value = names[names.length-1];
    document.getElementById('email').value = email;
  
  } ,
  
  goPro: function goPro() {
    // redirect to registration site; pass in the feature that brought user here
    let url;
    // short order process
    const shortOrder = "https://sites.fastspring.com/quickfolders/instant/quickfolders";
    // view product detail
    const productDetail = "http://sites.fastspring.com/quickfolders/product/quickfolders";
    let firstName = document.getElementById('firstName').value;
    let lastName = document.getElementById('lastName').value;
    let email = document.getElementById('email').value;
    let util = QuickFolders.Util; 
    
    url = shortOrder 
        + "?contact_fname=" + firstName 
        + "&contact_lname=" + lastName 
        + "&contact_email=" + email;
        
    let queryString = '';  // action=adds
    let featureName = document.getElementById('referrer').value;
    if (featureName) {
      queryString = "&referrer=" + featureName;
    }
    alert("The web shop is still work in progress - it will be ready for your order when the full version of QuickFolders Pro is released");
    util.openLinkInBrowser(null, url + queryString);
    window.close();
  }  ,

   /* obsolete form submission from code */
  postForm  : function postForm_obsolete(util) {
    let url ="http://sites.fastspring.com/quickfolders/product/quickfolders?action=order";
    let oReq;
    
    if (util.PlatformVersion >=16.0) {
      const XMLHttpRequest = Components.Constructor("@mozilla.org/xmlextras/xmlhttprequest;1", "nsIXMLHttpRequest");    
      oReq = new XMLHttpRequest();
    }
    else {
      const { XMLHttpRequest_Legacy } = Components.classes["@mozilla.org/appshell/appShellService;1"]
                                       .getService(Components.interfaces.nsIAppShellService)
                                       .hiddenDOMWindow;
      oReq = new XMLHttpRequest_Legacy();
    }
    // oReq.onload = reqListener;
    let formData = new FormData();
    formData.append("submit", "purchase");
    oReq.open("POST", url, true);
    oReq.send(formData);  
  } ,
  
  premiumInfo: function premiumInfo(event) {
    QuickFolders.Util.openURL(event,'http://quickfolders.mozdev.org/premium.html');
  },
  
  ELicenseState: {
    Valid: 1,
    Invalid: 2,
    Expired: 3,
    MailNotConfigured: 4
  },
  
  validateLicense: function validate(LicenseKey, Radix) {
    // extract encrypted portion after ;
    let encrypted = LicenseKey;
    // RSAKeyPair(encryptionExponent, decryptionExponent, modulus)
    // 64bit example
    // e= "36537a2e7669185",
    // d= "a60b25af8630d",
    // m= "3df615b2a67e2e7"
    QuickFolders.RSA.initialise(Radix);
    // we do not pass encryptionComponent as we don't need it for decryption
    let key = new QuickFolders.RSA.RSAKeyPair("", "A60B25AF8630D", "3DF615B2A67E2E7");
    // decrypt
    // verify against rest of string
    let RealLicense = QuickFolders.RSA.decryptedString(key, encrypted);
    if (!RealLicense)
      return this.ELicenseState.Invalid;
    alert('decrypted string: ' + RealLicense);
    // check mail components
    
    return [this.ELicenseState.Valid, RealLicense];
  },
  
  /*** for test only, will be removed **/
  encryptLicense: function encryptLicense(LicenseKey, Radix) {
    QuickFolders.RSA.initialise(Radix);
    // 64bit key pair
    let key = new QuickFolders.RSA.RSAKeyPair("36537A2E7669185", "A60B25AF8630D", "3DF615B2A67E2E7");
    let Encrypted = QuickFolders.RSA.encryptedString(key, LicenseKey);
    return Encrypted;
    
  }

}
